/*
 * NAME
 *    $HeadURL$
 * DESCRIPTION
 *    [given below in javadoc format]
 * COPYRIGHT
 *    (c) 2015 West Consulting BV
 * VERSION ID
 *    $Id$
 */
package nl.billinghouse.rme.utility;

import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import com.google.gson.JsonNull;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

/**
 * TODO Document me!
 *
 * @author skip
 */
public class JsonIO {
	public static String getString(JsonObject obj, String prop) {
		final JsonElement val = obj.get(prop);
		return (val == null || val == JsonNull.INSTANCE) ? null : val.getAsString();
	}

	//

	public static int getInt(JsonObject obj, String prop) {
		final JsonElement val = obj.get(prop);
		if (val == null || val == JsonNull.INSTANCE)
			throw new IllegalStateException();
		return val.getAsInt();
	}

	public static int getLong(JsonObject obj, String prop, int orElse) {
		final JsonElement val = obj.get(prop);
		return (val == null || val == JsonNull.INSTANCE) ? orElse : val.getAsInt();
	}

	//

	public static long getLong(JsonObject obj, String prop) {
		final JsonElement val = obj.get(prop);
		if (val == null || val == JsonNull.INSTANCE)
			throw new IllegalStateException();
		return val.getAsLong();
	}

	public static long getLong(JsonObject obj, String prop, long orElse) {
		final JsonElement val = obj.get(prop);
		return (val == null || val == JsonNull.INSTANCE) ? orElse : val.getAsLong();
	}

	//

	public static String toJson(JsonElement elem, boolean nonExec) {
		if (elem == null)
			throw new NullPointerException();
		GsonBuilder builder = new GsonBuilder();
		builder = builder.serializeNulls();
		if (nonExec)
			builder = builder.generateNonExecutableJson();
		builder = builder.setPrettyPrinting();
		return builder.create().toJson(elem);
	}

	public static String toJson(JsonElement elem) {
		return toJson(elem, false);
	}

	public static JsonElement fromJson(String json) {
		if (json == null)
			throw new NullPointerException();
		return new JsonParser().parse(json);
	}
}
