package nl.west.rme.common.util;

import java.text.Normalizer;


public class EmailSanitizer
{
  public static String sanitizeEmail(String email)
  {
    final String[] e = email.split("@");
    if (e.length != 2)
      throw new IllegalArgumentException("Bad e-mail address " + email);

    String username =
      Normalizer.normalize(e[0], Normalizer.Form.NFD).replaceAll(
          "([^\\p{ASCII}]|[^\\w\\.!#\\$%&'\\*\\+\\-/=\\?\\^`\\{\\|\\}~])+", "");
    username =
      username
          .replaceAll("\\.{2,}", ".").replaceFirst("^\\.+", "")
          .replaceFirst("\\.+$", "");

    if (username.isEmpty())
      throw new IllegalArgumentException("Bad e-mail address " + email);

    return username + "@" + e[1].trim();
  }

  public static String sanitizeGmail(String email)
  {
    final String[] g = email.split("@");
    if (g.length != 2)
      throw new IllegalArgumentException("Bad e-mail address " + email);

    String username =
      Normalizer.normalize(g[0], Normalizer.Form.NFD).replaceAll(
          "([^\\p{ASCII}]|[^\\w\\.'\\-])+", "");
    username =
      username
          .replaceAll("\\.{2,}", ".").replaceFirst("^\\.", "")
          .replaceFirst("\\.$", "");

    if (username.isEmpty())
      throw new IllegalArgumentException("Bad e-mail address " + email);

    return username + "@" + g[1].trim();
  }
}
